<template>
    <TransitionRoot
        :show="displayIndicator"
        enter="transition-opacity duration-1000"
        enter-from="opacity-0 left-0"
        enter-to="opacity-2 left-2"
        leave="transition-opacity duration-150"
        leave-from="opacity-100"
        leave-to="opacity-0"
    >
        <div class="h-full w-full place-content-center fixed pt-28 left-0" v-bind:class="displayIndicator ? 'flex' : 'hidden'">
            <div class="h-1/2 absolute left-5">
                <div class="absolute flex flex-col place-content-between h-full">
                    <div id="about-me-circle" class="rounded-full h-5 w-5 bg-blue-300"></div>
                    <div id="my-projects-circle" class="rounded-full h-5 w-5 bg-blue-300"></div>
                    <div id="my-skills-circle" class="rounded-full h-5 w-5 bg-blue-300"></div>
                    <div id="my-experiences-circle" class="rounded-full h-5 w-5 bg-blue-300"></div>
                    <div id="lets-get-in-touch-circle" class="rounded-full h-5 w-5 bg-blue-300"></div>
                </div>
                <div class="stick h-full w-1 mx-2 bg-blue-300">
                    
                </div>
            </div>
            <div class="flex flex-col place-content-between h-1/2 menu text-slate-500 absolute left-14 text-left font-semibold">
                <span v-for="sectionElement in sectionElements" :id="sectionElement.id + '-indicator'" class="hover:text-white hover:font-bold hover:text-base" @click="this.scrollToClick(sectionElement.id)">
                    {{sectionElement.name}}
                </span>
            </div>
        </div>
    </TransitionRoot>
</template>

<script>
    import { TransitionRoot } from '@headlessui/vue'

    export default {
        props: {
            sectionElements: Array
        },
        data() {
            return {
                displayIndicator: false,
            }
        },
        methods: {
            handleScroll () {
                // display scroll indicator
                if (window.scrollY >= window.innerHeight) {
                    this.displayIndicator = true;
                } else {
                    this.displayIndicator = false;
                };

                this.switchColor("about-me");
                this.switchColor("my-projects");
                this.switchColor("my-skills");
                this.switchColor("my-experiences");
                this.switchColor("lets-get-in-touch");
            },
            elementScrollBetween (el) {
                let elHeader = window.document.getElementById("header");

                return window.scrollY >= (el.offsetTop - elHeader.offsetHeight) && window.scrollY < (el.offsetTop + el.offsetHeight - elHeader.offsetHeight)
            },
            switchColor(id) {
                let elIndicator = window.document.getElementById(id + "-indicator");
                let el = window.document.getElementById(id);
                let elCircle = window.document.getElementById(id + "-circle");
                if(this.elementScrollBetween(el)) {
                    elIndicator.classList.add("text-white", "font-bold", "text-base");
                    elCircle.classList.add("bg-white");
                } else {
                    elIndicator.classList.remove("text-white", "font-bold", "text-base");
                    elCircle.classList.remove("bg-white");
                }
            },
            scrollToClick(id) {
                window.scrollTo({
                    top: window.document.getElementById(id).offsetTop - window.document.getElementById("header").offsetHeight,
                    left: 0,
                    behavior: 'smooth'
                });
                window.document.getElementById(id).scrollIntoView
            }
        }, 
        beforeMount () {
            window.addEventListener('scroll', this.handleScroll);
        },
        beforeDestroy() {
            window.removeEventListener('scroll', this.handleScroll);
        }
    }
</script>